var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../core/BindableProperty", "../../view-model/AtomWindowViewModel", "../styles/AtomAlertWindowStyle", "./AtomControl", "./AtomWindow"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var BindableProperty_1 = require("../../core/BindableProperty");
    var AtomWindowViewModel_1 = require("../../view-model/AtomWindowViewModel");
    var AtomAlertWindowStyle_1 = require("../styles/AtomAlertWindowStyle");
    var AtomControl_1 = require("./AtomControl");
    var AtomWindow_1 = require("./AtomWindow");
    var AtomAlertWindow = /** @class */ (function (_super) {
        __extends(AtomAlertWindow, _super);
        function AtomAlertWindow() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AtomAlertWindow.prototype.create = function () {
            this.defaultControlStyle = AtomAlertWindowStyle_1.default;
            this.viewModel = this.resolve(AtomAlertViewModel);
            this.windowTemplate = AtomAlertWindowTemplate;
            this.commandTemplate = AtomAlertWindowCommandBar;
            // this.bind(this.element, "title", [["viewModel", "title"]]);
        };
        return AtomAlertWindow;
    }(AtomWindow_1.AtomWindow));
    exports.default = AtomAlertWindow;
    var AtomAlertWindowTemplate = /** @class */ (function (_super) {
        __extends(AtomAlertWindowTemplate, _super);
        function AtomAlertWindowTemplate() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AtomAlertWindowTemplate.prototype.create = function () {
            var div = document.createElement("div");
            this.append(div);
            this.bind(div, "formattedText", [["viewModel", "message"]]);
        };
        return AtomAlertWindowTemplate;
    }(AtomControl_1.AtomControl));
    var AtomAlertWindowCommandBar = /** @class */ (function (_super) {
        __extends(AtomAlertWindowCommandBar, _super);
        function AtomAlertWindowCommandBar() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AtomAlertWindowCommandBar.prototype.create = function () {
            var _this = this;
            var okButton = document.createElement("button");
            var cancelButton = document.createElement("button");
            this.append(okButton);
            this.append(cancelButton);
            this.setPrimitiveValue(okButton, "class", "yes-button");
            this.setPrimitiveValue(cancelButton, "class", "no-button");
            this.bind(okButton, "text", [["viewModel", "okTitle"]]);
            this.bind(cancelButton, "text", [["viewModel", "cancelTitle"]]);
            this.bind(okButton, "styleDisplay", [["viewModel", "okTitle"]], false, function (v) { return v ? "" : "none"; });
            this.bind(okButton, "styleMarginBottom", [["viewModel", "cancelTitle"]], false, function (v) { return v ? "0" : "10px"; });
            this.bind(cancelButton, "styleDisplay", [["viewModel", "cancelTitle"]], false, function (v) { return v ? "" : "none"; });
            this.bindEvent(okButton, "click", function (e) {
                _this.viewModel.onOkClicked();
            });
            this.bindEvent(cancelButton, "click", function (e) {
                _this.viewModel.onCancelClicked();
            });
        };
        return AtomAlertWindowCommandBar;
    }(AtomControl_1.AtomControl));
    var AtomAlertViewModel = /** @class */ (function (_super) {
        __extends(AtomAlertViewModel, _super);
        function AtomAlertViewModel() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AtomAlertViewModel.prototype.onOkClicked = function () {
            this.close(true);
        };
        AtomAlertViewModel.prototype.onCancelClicked = function () {
            this.cancel();
        };
        __decorate([
            BindableProperty_1.BindableProperty,
            __metadata("design:type", String)
        ], AtomAlertViewModel.prototype, "title", void 0);
        __decorate([
            BindableProperty_1.BindableProperty,
            __metadata("design:type", String)
        ], AtomAlertViewModel.prototype, "message", void 0);
        __decorate([
            BindableProperty_1.BindableProperty,
            __metadata("design:type", String)
        ], AtomAlertViewModel.prototype, "okTitle", void 0);
        __decorate([
            BindableProperty_1.BindableProperty,
            __metadata("design:type", String)
        ], AtomAlertViewModel.prototype, "cancelTitle", void 0);
        return AtomAlertViewModel;
    }(AtomWindowViewModel_1.AtomWindowViewModel));
});
//# sourceMappingURL=AtomAlertWindow.js.map